#include <stdio.h>
#include <stdlib.h>
#define _WIN32_WINNT 0x0500
#include <windows.h>

#define PORT_1 54321
#define PORT_2 54322
#define MAXCONN 5

HANDLE mainThread = NULL;

void waitForeverInServerSocket()
{
	int fd, err1, err2;
	SOCKADDR_IN sockaddr;
	fd_set mask;

	/* Setup a listening server socket */
	sockaddr.sin_family = AF_INET;
	sockaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	sockaddr.sin_port = htons(PORT_1);
	fd = socket(AF_INET, SOCK_STREAM, 0);
	err1 = bind(fd, (SOCKADDR FAR*)&sockaddr, sizeof(SOCKADDR_IN));
	err2 = listen(fd,MAXCONN);
	if (fd == INVALID_SOCKET || err1 == SOCKET_ERROR || err2 == SOCKET_ERROR)
	{
		printf("Something broke\n");
		exit(1);
	}

	/* This select should never return (without external prompting) */
	FD_ZERO(&mask);
	FD_SET(fd,&mask);
	printf("waiting (forever?) in select...\n");
	err1 = select(fd+1,&mask,NULL,NULL,NULL);

	printf("select RETURNED %d => FD_ISSET = %d [error %i]\n",err1,FD_ISSET(fd,&mask),(int)WSAGetLastError());
}


/* APC which runs on main thread */
static void CALLBACK apc_func(unsigned long param)
{
	int fd;
	SOCKADDR_IN sockaddr;
	printf("APC called\n");

	sockaddr.sin_family = AF_INET;
	sockaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	sockaddr.sin_port = htons(PORT_2);

#if 0
	fd = socket(AF_INET, SOCK_STREAM, 0);
#endif
}


static DWORD WINAPI send_APC(LPVOID param)
{
	Sleep(2500);
	printf("sending APC\n");
	QueueUserAPC(apc_func,mainThread,0);
	return 0;
}


int main(void)
{
	DWORD tID;
	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,2), &wsaData);

	setvbuf(stdout,NULL,_IONBF,0);
	setvbuf(stderr,NULL,_IONBF,0);

	/* Setup main thread handle */
	DuplicateHandle(GetCurrentProcess(), GetCurrentThread(),
					GetCurrentProcess(), &mainThread,
					0, FALSE, DUPLICATE_SAME_ACCESS);

    /* Thread waits for a short period, and then fires off an APC */
	//CreateThread(NULL,0,send_APC,NULL,0,NULL);
	_beginthreadex(NULL, 0, send_APC, NULL, 0, &tID);

	/* Run the server */
	waitForeverInServerSocket();

	return 0;
}
